/*48008660*/
#include "../include/avl.h"
#include "../include/colaAvls.h"
#include "../include/pila.h"
#include "../include/binario.h"
#include "../include/cadena.h"
#include "../include/info.h"
#include "../include/utils.h"
#include "../include/usoTads.h"
#include "../include/iterador.h"
#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>



//***************************MI SOLUCION******************************
nat max(nat a,nat b);
void insertarEnAvl2(nat elem, TAvl & avl);
void inOrden (TAvl b,TIterador & lin);
nat cantidadAvl2(TAvl b);
int desencolarq( struct cola &q );
void encolarq( struct cola &q, int valor );
void imprimirBinario2avl(TAvl b,int cont);
void imprimirBinarioavl(TAvl b);
bool noOrdenadosoconRepetidos(nat *elems, nat n);
void insertarEnAvl3(nat elem, TAvl & avl);
TAvl insertarEnAvl4(nat elem, TAvl avl);
void rotarIzquierda2 ( TAvl & avl );
void rotarDerecha2 ( TAvl & avl);
void insertarNodo (TAvl & avl, nat i);
nat alturaBinario(TAvl b);
TAvl insertarEnTavl(nat i, TAvl b);
TCadena factorial(nat n, TCadena cadena, nat sumador);
TCadena factorial2(nat n, TCadena cadena, nat sumador);


//*************************************************************

struct repAvl{
  nat dato;
  nat altura;
  nat cantidad;
  TAvl izq,der;
};

 
/*                Estructura de los nodos de la cola      
------------------------------------------------------------------------*/
struct nodo
{
    int nro;
    struct nodo *sgte;
};
 
 
/*                      Estructura de la cola      
------------------------------------------------------------------------*/
struct cola
{
    nodo *delante;
    nodo *atras  ;
};
 
 cola crearcola (){
    struct cola q;
   
    q.delante = NULL;
    q.atras   = NULL;
 return q;
}









/*
  Devuelve un 'TAvl' vacío (sin elementos).
  El tiempo de ejecución en el peor caso es O(1).
 */
TAvl crearAvl(){ return NULL;}



/*
  Devuelve 'true' si y solo si 'avl' es vacío (no tiene elementos).
  El tiempo de ejecución en el peor caso es O(1).
 */

bool estaVacioAvl(TAvl avl){
    return (avl==NULL);
}

/*
  Libera la memoria asignada a 'TAvl'.
  El tiempo de ejecución en el peor caso es O(n), siendo 'n' la cantidad de
  elementos de 'TAvl'.
  El tiempo de ejecución en el peor caso es O(n), siendo 'n' la cantidad
  de elementos de 'avl'.
 */

void liberarAvl (TAvl avl) {
if (avl != NULL) {
  liberarAvl(avl->izq);
  liberarAvl(avl->der);
  delete avl;
  }
}


/*
  Devuelve el elemento asociado a la raíz de 'avl'.
  Precondición: ! esVacioAvl(b).
  El tiempo de ejecución en el peor caso es O(1).
 */
nat raizAvl(TAvl avl){
  assert(!estaVacioAvl(avl));
    return avl->dato;
}



void rotarDerecha ( TAvl & avl) { // precond : z y z - > izq != NULL
assert((avl!=NULL) && (avl->izq!=NULL ));
TAvl y = avl-> izq ;
TAvl T3 = y-> der ;
y-> der = avl;
avl-> izq = T3 ;
avl-> altura = max ( alturaDeAvl (avl-> izq ) , alturaDeAvl (avl-> der ) ) + 1;
y-> altura = max ( alturaDeAvl (y-> izq ) , alturaDeAvl (y-> der ) ) + 1;
avl = y;

}

void rotarIzquierda ( TAvl & avl ) { // precond : el z y z - > der != NULL
assert((avl!=NULL) && (avl->der!=NULL ));

TAvl y = avl-> der ;
TAvl T2 = y-> izq ;
y-> izq = avl ;

avl-> der = T2 ;

avl-> altura = max ( alturaDeAvl (avl-> izq ) , alturaDeAvl (avl-> der ) ) +1;
y-> altura = max ( alturaDeAvl (y-> izq ) , alturaDeAvl (y-> der ) ) +1;

avl = y;

}



















/*
  Inserta 'elem' en 'avl' respetando la propiedad de orden definida.
  Precondición: esVacioAvl(buscarEnAvl(elem, TAvl).
  Devuelve 'avl'.
  El tiempo de ejecución en el peor caso es O(log n), siendo 'n' la cantidad
  de elementos de 'avl'.
*/
TAvl insertarEnAvl(nat elem, TAvl avl){
assert(estaVacioAvl(buscarEnAvl(elem, avl)));
insertarEnAvl2(elem,avl);
 return avl;
}




void insertarEnAvl2(nat elem, TAvl & avl){


    if (avl== NULL){
      avl= new repAvl;
      avl->dato= elem;
      avl->izq= avl->der= NULL;
      avl->altura= 1;
      avl->cantidad=1;
    } 

    else {
     if (elem< avl->dato){
      insertarEnAvl2(elem,avl->izq);
      avl->altura=max(alturaDeAvl(avl->izq),alturaDeAvl(avl->der))+1;
      avl->cantidad=avl->cantidad+1;
      int FB= alturaDeAvl(avl->izq)-alturaDeAvl(avl->der);

      if(FB>1) {
          if(alturaDeAvl(avl->izq->izq)>alturaDeAvl(avl->izq->der))
          {
          rotarDerecha(avl);
          if(avl->der!=NULL){
            avl->der->cantidad=cantidadEnAvl(avl->der->izq)+cantidadEnAvl(avl->der->der)+1;
          avl->cantidad=cantidadEnAvl(avl->izq)+cantidadEnAvl(avl->der)+1;
          }
           
         }
          else{
            rotarIzquierda(avl->izq);
            if(avl->izq->izq!=NULL) {
            avl->izq->izq->cantidad=cantidadEnAvl(avl->izq->izq->izq)+cantidadEnAvl(avl->izq->izq->der)+1;
            avl->izq->cantidad=cantidadEnAvl(avl->izq->izq)+cantidadEnAvl(avl->izq->der)+1;
            }
            rotarDerecha(avl);
            if (avl->der!=NULL)
            {
            
            avl->der->cantidad=cantidadEnAvl(avl->der->izq)+cantidadEnAvl(avl->der->der)+1;
            avl->cantidad=cantidadEnAvl(avl->izq)+cantidadEnAvl(avl->der)+1;
           }
          }
         }
        }
      else {  // rlrm mayor que dato 
          insertarEnAvl2(elem,avl->der);
         
          avl->altura=max(alturaDeAvl(avl->izq),alturaDeAvl(avl->der))+1;
          avl->cantidad=avl->cantidad+1;
          //balanceo
          int FB= alturaDeAvl(avl->izq)-alturaDeAvl(avl->der);

           if(FB< -1) {

          if(alturaDeAvl(avl->der->der)>alturaDeAvl(avl->der->izq)){
 
          rotarIzquierda(avl);
          if( avl->izq!=NULL){
          avl->izq->cantidad=cantidadEnAvl(avl->izq->izq)+cantidadEnAvl(avl->izq->der)+1;
           avl->cantidad=cantidadEnAvl(avl->izq)+cantidadEnAvl(avl->der)+1;
           }
          
          }

          else{
             rotarDerecha(avl->der);
             if(avl->der->der!=NULL){
             avl->der->der->cantidad=cantidadEnAvl(avl->der->der->izq)+cantidadEnAvl(avl->der->der->der)+1;

              avl->der->cantidad=cantidadEnAvl(avl->der->izq)+cantidadEnAvl(avl->der->der)+1;
              }

            rotarIzquierda(avl);
            if(avl->izq->izq!=NULL) {
            avl->izq->izq->cantidad=cantidadEnAvl(avl->izq->izq->izq)+cantidadEnAvl(avl->izq->izq->der)+1;
           avl->izq->cantidad=cantidadEnAvl(avl->izq->izq)+cantidadEnAvl(avl->izq->der)+1;
           }
          }
      }
    }
   
}
}



//↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑  LETRA  ↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑


nat max(nat a,nat b){
if(a>b){
  return a;
} else{
  return b;
}
}





/*
  Devuelve el subárbol cuya raíz es 'elem'.
  Si ningún nodo cumple esa condición devuelve el árbol vacío.
  El 'TAvl' resultado comparte memoria con el parámetro.
  El tiempo de ejecución en el peor caso es O(log n), siendo 'n' la cantidad
  de elementos de 'avl'.
 */
TAvl buscarEnAvl(nat elem, TAvl avl){
  TAvl res;
    if (avl==NULL){
      res=NULL;
    } else if(avl->dato==elem){ 
      res=avl;} 
    else if (elem < avl->dato)
    {
      res= buscarEnAvl(elem,avl->izq);
    } else {
      res=buscarEnAvl(elem,avl->der);
    }
    return res;
}


/*
  Devuelve el subárbol izquierdo de 'avl'.
  Precondición: ! esVacioAvl(TAvl).
  El 'TAvl' resultado comparte memoria con el parámetro.
  El tiempo de ejecución en el peor caso es O(1).
 */
TAvl izqAvl(TAvl avl){
  assert(! estaVacioAvl(avl));
    return avl->izq;
}

/*
  Devuelve el subárbol derecho de 'avl'.
  Precondición: ! esVacioAvl(TAvl).
  El 'TAvl' resultado comparte memoria con el parámetro.
  El tiempo de ejecución en el peor caso es O(1).
 */
TAvl derAvl(TAvl avl){
  assert(!estaVacioAvl(avl));
    return avl->der;
}

/*
  Devuelve la cantidad de elementos en 'avl'.
  El tiempo de ejecución en el peor caso es O(1).
 */
nat cantidadEnAvl(TAvl avl){
  if(avl==NULL) {
    return 0;
  } else {
    return avl->cantidad;
  } 
}

/*
  Devuelve la altura de 'avl'.
  La altura de un árbol vacío es 0.
  El tiempo de ejecución en el peor caso es O(1).
 */
nat alturaDeAvl(TAvl avl){
  if (avl==NULL){
    return 0;
  } else{
    return avl->altura;
    }
}

/*
  Devuelve un 'TIterador' de los elementos de 'c'.
  En la recorrida del iterador devuelto los elementos aparecerán en orden
  creciente.
  El 'TIterador' resultado no comparte memoria con 'avl'.
  El tiempo de ejecución en el peor caso es O(n) siendo 'n' la cantidad de
  elementos de 'avl'.
 */
TIterador enOrdenAvl(TAvl avl){
TIterador lin=  crearIterador();
if (avl==NULL) return lin;
/*
if (avl->cantidad==1) {
  lin = agregarAIterador(raizAvl(avl),lin);
 //lin= reiniciarIterador(lin);
  return lin;
}
*/
inOrden(avl,lin);
//printf("\n Llamada de memoria de *puntero es: %p",b);
//lin= reiniciarIterador(lin);
return  lin;
}





void inOrden (TAvl b,TIterador & lin){
//TCadena lin=  NULL;
if(b==NULL){
//  printf("\n null        de memoria de *puntero es: %p",b);
  return;
}
else {
inOrden(b->izq,lin);
//printf("\n Antes *puntero es: %p",lin);
lin = agregarAIterador(b->dato,lin);
//printf("\n Despues de memoria de *puntero es: %p",lin);
inOrden(b->der,lin);
}
}

/*
  Devuelve un 'TAvl' con los 'n' elementos que están en el rango [0 .. n - 1]
  del arreglo 'elems'.
  Precondiciones:
  - n > 0
  - Los elementos están ordenados de manera creciente estricto
  (creciente y sin  repetidos).
  En cada nodo del árbol resultado la cantidad de elementos de su subárbol
  izquierdo es igual a, o 1 menos que, la cantidad de elementos de su subárbol
  derecho.
  El tiempo de ejecución en el peor caso es O(n).
 */
TAvl arregloAAvl(nat *elems, nat n){
  TAvl nuevo=crearAvl();
  assert((n>0)&& !noOrdenadosoconRepetidos(elems,n));
    for (unsigned int i=0;i<=n-1;i++){
      nuevo=insertarEnAvl(elems[i],nuevo);
     //  printf("necesito chequear si por lo menos entro \n");
    }
   // imprimirAvl(nuevo);
    return nuevo;
}

bool noOrdenadosoconRepetidos(nat *elems, nat n){
  bool repetidoomenor=false;
  for (unsigned int i=0;i<=n-1;i++){
    if((i-1)<0){
      if(elems[i]>=elems[i-1]){
        repetidoomenor=true;}
       // printf("necesito chequear si recorre \n");
        }else {

        }
}
return repetidoomenor;
}
/*
  Devuelve un 'TAvl' de altura 'h' con 'n' nodos, siendo 'n' la mínima cantidad
  de elementos que puede tener un 'TAvl' de altura 'h'.
  Los elementos van desde 1 hasta 'n'.
  En ningún nodo puede ocurrir que el subárbol derecho tenga más nodos que el
  subárbol izquierdo.
  La altura de un árbol vacío es 0.
  El tiempo de ejecución en el peor caso es O(n).
  Ver ejemplos en la letra.
 */
TAvl avlMin(nat h){
 
 // nat foo [] = {};
   nat vector[] = {1};
  nat vector2[] = {2 ,1};
  nat vector3[] = {3,2,4,1};
  nat vector4[] = {5,3,7,2,4,6,1};
 nat  vector5[] = {8,5,11,3,7,10,12,2,4,6,9,1};
nat vector6[] = {13,8,18,5,11,16,20,3,7,10,12,15,17,19,2,4,6,9,14,1	};
nat vector7[] = {21,13,29,8,18,26,32,5,11,16,20,24,28,31,33,3,7,10,12,15,17,19,23,25,27,30,2,4,6,9,14,22,1};
nat  vector8[] = {34,21,47,13,29,42,52,8,18,26,32,39,45,50,54,5,11,16,20,24,28,31,33,37,41,44,46,49,51,53,3,7,10,12,15,17,19,23,25,27,30,36,38,40,43,48,2,4,6,9,14,22,35,1};
nat vector9[] = { 55,34,76,21,47,68,84,13,29,42,52,63,73,81,87,8,18,26,32,39,45,50,54,60,66,71,75,79,83,86,88,5,11,16,20,24,28,31,33,37,41,44,46,49,51,53,58,62,65,67,70,72,74,78,80,82,85,3,7,10,12,15,17,19,23,25,27,30,36,38,40,43,48,57,59,61,64,69,77,2,4,6,9,14,22,35,56,1};
nat  vector10[] = {89,55,123,34,76,110,136,21,47,68,84,102,118,131,141,13,29,42,52,63,73,81,87,97,107,115,121,128,134,139,143,8,18,26,32,39,45,50,54,60,66,71,75,79,83,86,88,94,100,105,109,113,117,120,122,126,130,133,135,138,140,142,5,11,16,20,24,28,31,33,37,41,44,46,49,51,53,58,62,65,67,70,72,74,78,80,82,85,92,96,99,101,104,106,108,112,114,116,119,125,127,129,132,137,3,7,10,12,15,17,19,23,25,27,30,36,38,40,43,48,57,59,61,64,69,77,91,93,95,98,103,111,124,2,4,6,9,14,22,35,56,90,1};
nat  vector11[] = { 144,89,199,55,123,178,220,34,76,110,136,165,191,212,228,21,47,68,84,102,118,131,141,157,173,186,196,207,217,225,231,13,29,42,52,63,73,81,87,97,107,115,121,128,134,139,143,152,162,170,176,183,189,194,198,204,210,215,219,223,227,230,232,8,18,26,32,39,45,50,54,60,66,71,75,79,83,86,88,94,100,105,109,113,117,120,122,126,130,133,135,138,140,142,149,155,160,164,168,172,175,177,181,185,188,190,193,195,197,202,206,209,211,214,216,218,222,224,226,229,5,11,16,20,24,28,31,33,37,41,44,46,49,51,53,58,62,65,67,70,72,74,78,80,82,85,92,96,99,101,104,106,108,112,114,116,119,125,127,129,132,137,147,151,154,156,159,161,163,167,169,171,174,180,182,184,187,192,201,203,205,208,213,221,3,7,10,12,15,17,19,23,25,27,30,36,38,40,43,48,57,59,61,64,69,77,91,93,95,98,103,111,124,146,148,150,153,158,166,179,200,2,4,6,9,14,22,35,56,90,145,1};
nat  vector12[] = { 233,144,322,89,199,288,356,55,123,178,220,267,309,343,369,34,76,110,136,165,191,212,228,254,280,301,317,335,351,364,374,21,47,68,84,102,118,131,141,157,173,186,196,207,217,225,231,246,262,275,285,296,306,314,320,330,340,348,354,361,367,372,376,13,29,42,52,63,73,81,87,97,107,115,121,128,134,139,143,152,162,170,176,183,189,194,198,204,210,215,219,223,227,230,232,241,251,259,265,272,278,283,287,293,299,304,308,312,316,319,321,327,333,338,342,346,350,353,355,359,363,366,368,371,373,375,8,18,26,32,39,45,50,54,60,66,71,75,79,83,86,88,94,100,105,109,113,117,120,122,126,130,133,135,138,140,142,149,155,160,164,168,172,175,177,181,185,188,190,193,195,197,202,206,209,211,214,216,218,222,224,226,229,238,244,249,253,257,261,264,266,270,274,277,279,282,284,286,291,295,298,300,303,305,307,311,313,315,318,325,329,332,334,337,339,341,345,347,349,352,358,360,362,365,370,5,11,16,20,24,28,31,33,37,41,44,46,49,51,53,58,62,65,67,70,72,74,78,80,82,85,92,96,99,101,104,106,108,112,114,116,119,125,127,129,132,137,147,151,154,156,159,161,163,167,169,171,174,180,182,184,187,192,201,203,205,208,213,221,236,240,243,245,248,250,252,256,258,260,263,269,271,273,276,281,290,292,294,297,302,310,324,326,328,331,336,344,357,3,7,10,12,15,17,19,23,25,27,30,36,38,40,43,48,57,59,61,64,69,77,91,93,95,98,103,111,124,146,148,150,153,158,166,179,200,235,237,239,242,247,255,268,289,323,2,4,6,9,14,22,35,56,90,145,234,1};
nat  vector13[] = {377,233,521,144,322,466,576,89,199,288,356,432,500,555,597,55,123,178,220,267,309,343,369,411,453,487,513,542,568,589,605,34,76,110,136,165,191,212,228,254,280,301,317,335,351,364,374,398,424,445,461,479,495,508,518,534,550,563,573,584,594,602,608,21,47,68,84,102,118,131,141,157,173,186,196,207,217,225,231,246,262,275,285,296,306,314,320,330,340,348,354,361,367,372,376,390,406,419,429,440,450,458,464,474,484,492,498,505,511,516,520,529,539,547,553,560,566,571,575,581,587,592,596,600,604,607,609,13,29,42,52,63,73,81,87,97,107,115,121,128,134,139,143,152,162,170,176,183,189,194,198,204,210,215,219,223,227,230,232,241,251,259,265,272,278,283,287,293,299,304,308,312,316,319,321,327,333,338,342,346,350,353,355,359,363,366,368,371,373,375,385,395,403,409,416,422,427,431,437,443,448,452,456,460,463,465,471,477,482,486,490,494,497,499,503,507,510,512,515,517,519,526,532,537,541,545,549,552,554,558,562,565,567,570,572,574,579,583,586,588,591,593,595,599,601,603,606,8,18,26,32,39,45,50,54,60,66,71,75,79,83,86,88,94,100,105,109,113,117,120,122,126,130,133,135,138,140,142,149,155,160,164,168,172,175,177,181,185,188,190,193,195,197,202,206,209,211,214,216,218,222,224,226,229,238,244,249,253,257,261,264,266,270,274,277,279,282,284,286,291,295,298,300,303,305,307,311,313,315,318,325,329,332,334,337,339,341,345,347,349,352,358,360,362,365,370,382,388,393,397,401,405,408,410,414,418,421,423,426,428,430,435,439,442,444,447,449,451,455,457,459,462,469,473,476,478,481,483,485,489,491,493,496,502,504,506,509,514,524,528,531,533,536,538,540,544,546,548,551,557,559,561,564,569,578,580,582,585,590,598,5,11,16,20,24,28,31,33,37,41,44,46,49,51,53,58,62,65,67,70,72,74,78,80,82,85,92,96,99,101,104,106,108,112,114,116,119,125,127,129,132,137,147,151,154,156,159,161,163,167,169,171,174,180,182,184,187,192,201,203,205,208,213,221,236,240,243,245,248,250,252,256,258,260,263,269,271,273,276,281,290,292,294,297,302,310,324,326,328,331,336,344,357,380,384,387,389,392,394,396,400,402,404,407,413,415,417,420,425,434,436,438,441,446,454,468,470,472,475,480,488,501,523,525,527,530,535,543,556,577,3,7,10,12,15,17,19,23,25,27,30,36,38,40,43,48,57,59,61,64,69,77,91,93,95,98,103,111,124,146,148,150,153,158,166,179,200,235,237,239,242,247,255,268,289,323,379,381,383,386,391,399,412,433,467,522,2,4,6,9,14,22,35,56,90,145,234,378,1};
nat  vector14[] = {610,377,843,233,521,754,932,144,322,466,576,699,809,898,966,89,199,288,356,432,500,555,597,665,733,788,830,877,919,953,979,55,123,178,220,267,309,343,369,411,453,487,513,542,568,589,605,644,686,720,746,775,801,822,838,864,890,911,927,945,961,974,984,34,76,110,136,165,191,212,228,254,280,301,317,335,351,364,374,398,424,445,461,479,495,508,518,534,550,563,573,584,594,602,608,631,657,678,694,712,728,741,751,767,783,796,806,817,827,835,841,856,872,885,895,906,916,924,930,940,950,958,964,971,977,982,986,21,47,68,84,102,118,131,141,157,173,186,196,207,217,225,231,246,262,275,285,296,306,314,320,330,340,348,354,361,367,372,376,390,406,419,429,440,450,458,464,474,484,492,498,505,511,516,520,529,539,547,553,560,566,571,575,581,587,592,596,600,604,607,609,623,639,652,662,673,683,691,697,707,717,725,731,738,744,749,753,762,772,780,786,793,799,804,808,814,820,825,829,833,837,840,842,851,861,869,875,882,888,893,897,903,909,914,918,922,926,929,931,937,943,948,952,956,960,963,965,969,973,976,978,981,983,985,13,29,42,52,63,73,81,87,97,107,115,121,128,134,139,143,152,162,170,176,183,189,194,198,204,210,215,219,223,227,230,232,241,251,259,265,272,278,283,287,293,299,304,308,312,316,319,321,327,333,338,342,346,350,353,355,359,363,366,368,371,373,375,385,395,403,409,416,422,427,431,437,443,448,452,456,460,463,465,471,477,482,486,490,494,497,499,503,507,510,512,515,517,519,526,532,537,541,545,549,552,554,558,562,565,567,570,572,574,579,583,586,588,591,593,595,599,601,603,606,618,628,636,642,649,655,660,664,670,676,681,685,689,693,696,698,704,710,715,719,723,727,730,732,736,740,743,745,748,750,752,759,765,770,774,778,782,785,787,791,795,798,800,803,805,807,812,816,819,821,824,826,828,832,834,836,839,848,854,859,863,867,871,874,876,880,884,887,889,892,894,896,901,905,908,910,913,915,917,921,923,925,928,935,939,942,944,947,949,951,955,957,959,962,968,970,972,975,980,8,18,26,32,39,45,50,54,60,66,71,75,79,83,86,88,94,100,105,109,113,117,120,122,126,130,133,135,138,140,142,149,155,160,164,168,172,175,177,181,185,188,190,193,195,197,202,206,209,211,214,216,218,222,224,226,229,238,244,249,253,257,261,264,266,270,274,277,279,282,284,286,291,295,298,300,303,305,307,311,313,315,318,325,329,332,334,337,339,341,345,347,349,352,358,360,362,365,370,382,388,393,397,401,405,408,410,414,418,421,423,426,428,430,435,439,442,444,447,449,451,455,457,459,462,469,473,476,478,481,483,485,489,491,493,496,502,504,506,509,514,524,528,531,533,536,538,540,544,546,548,551,557,559,561,564,569,578,580,582,585,590,598,615,621,626,630,634,638,641,643,647,651,654,656,659,661,663,668,672,675,677,680,682,684,688,690,692,695,702,706,709,711,714,716,718,722,724,726,729,735,737,739,742,747,757,761,764,766,769,771,773,777,779,781,784,790,792,794,797,802,811,813,815,818,823,831,846,850,853,855,858,860,862,866,868,870,873,879,881,883,886,891,900,902,904,907,912,920,934,936,938,941,946,954,967,5,11,16,20,24,28,31,33,37,41,44,46,49,51,53,58,62,65,67,70,72,74,78,80,82,85,92,96,99,101,104,106,108,112,114,116,119,125,127,129,132,137,147,151,154,156,159,161,163,167,169,171,174,180,182,184,187,192,201,203,205,208,213,221,236,240,243,245,248,250,252,256,258,260,263,269,271,273,276,281,290,292,294,297,302,310,324,326,328,331,336,344,357,380,384,387,389,392,394,396,400,402,404,407,413,415,417,420,425,434,436,438,441,446,454,468,470,472,475,480,488,501,523,525,527,530,535,543,556,577,613,617,620,622,625,627,629,633,635,637,640,646,648,650,653,658,667,669,671,674,679,687,701,703,705,708,713,721,734,756,758,760,763,768,776,789,810,845,847,849,852,857,865,878,899,933,3,7,10,12,15,17,19,23,25,27,30,36,38,40,43,48,57,59,61,64,69,77,91,93,95,98,103,111,124,146,148,150,153,158,166,179,200,235,237,239,242,247,255,268,289,323,379,381,383,386,391,399,412,433,467,522,612,614,616,619,624,632,645,666,700,755,844,2,4,6,9,14,22,35,56,90,145,234,378,611,1	};
nat  vector15[] = { 987,610,1364,377,843,1220,1508,233,521,754,932,1131,1309,1453,1563,144,322,466,576,699,809,898,966,1076,1186,1275,1343,1419,1487,1542,1584,89,199,288,356,432,500,555,597,665,733,788,830,877,919,953,979,1042,1110,1165,1207,1254,1296,1330,1356,1398,1440,1474,1500,1529,1555,1576,1592,55,123,178,220,267,309,343,369,411,453,487,513,542,568,589,605,644,686,720,746,775,801,822,838,864,890,911,927,945,961,974,984,1021,1063,1097,1123,1152,1178,1199,1215,1241,1267,1288,1304,1322,1338,1351,1361,1385,1411,1432,1448,1466,1482,1495,1505,1521,1537,1550,1560,1571,1581,1589,1595,34,76,110,136,165,191,212,228,254,280,301,317,335,351,364,374,398,424,445,461,479,495,508,518,534,550,563,573,584,594,602,608,631,657,678,694,712,728,741,751,767,783,796,806,817,827,835,841,856,872,885,895,906,916,924,930,940,950,958,964,971,977,982,986,1008,1034,1055,1071,1089,1105,1118,1128,1144,1160,1173,1183,1194,1204,1212,1218,1233,1249,1262,1272,1283,1293,1301,1307,1317,1327,1335,1341,1348,1354,1359,1363,1377,1393,1406,1416,1427,1437,1445,1451,1461,1471,1479,1485,1492,1498,1503,1507,1516,1526,1534,1540,1547,1553,1558,1562,1568,1574,1579,1583,1587,1591,1594,1596,21,47,68,84,102,118,131,141,157,173,186,196,207,217,225,231,246,262,275,285,296,306,314,320,330,340,348,354,361,367,372,376,390,406,419,429,440,450,458,464,474,484,492,498,505,511,516,520,529,539,547,553,560,566,571,575,581,587,592,596,600,604,607,609,623,639,652,662,673,683,691,697,707,717,725,731,738,744,749,753,762,772,780,786,793,799,804,808,814,820,825,829,833,837,840,842,851,861,869,875,882,888,893,897,903,909,914,918,922,926,929,931,937,943,948,952,956,960,963,965,969,973,976,978,981,983,985,1000,1016,1029,1039,1050,1060,1068,1074,1084,1094,1102,1108,1115,1121,1126,1130,1139,1149,1157,1163,1170,1176,1181,1185,1191,1197,1202,1206,1210,1214,1217,1219,1228,1238,1246,1252,1259,1265,1270,1274,1280,1286,1291,1295,1299,1303,1306,1308,1314,1320,1325,1329,1333,1337,1340,1342,1346,1350,1353,1355,1358,1360,1362,1372,1382,1390,1396,1403,1409,1414,1418,1424,1430,1435,1439,1443,1447,1450,1452,1458,1464,1469,1473,1477,1481,1484,1486,1490,1494,1497,1499,1502,1504,1506,1513,1519,1524,1528,1532,1536,1539,1541,1545,1549,1552,1554,1557,1559,1561,1566,1570,1573,1575,1578,1580,1582,1586,1588,1590,1593,13,29,42,52,63,73,81,87,97,107,115,121,128,134,139,143,152,162,170,176,183,189,194,198,204,210,215,219,223,227,230,232,241,251,259,265,272,278,283,287,293,299,304,308,312,316,319,321,327,333,338,342,346,350,353,355,359,363,366,368,371,373,375,385,395,403,409,416,422,427,431,437,443,448,452,456,460,463,465,471,477,482,486,490,494,497,499,503,507,510,512,515,517,519,526,532,537,541,545,549,552,554,558,562,565,567,570,572,574,579,583,586,588,591,593,595,599,601,603,606,618,628,636,642,649,655,660,664,670,676,681,685,689,693,696,698,704,710,715,719,723,727,730,732,736,740,743,745,748,750,752,759,765,770,774,778,782,785,787,791,795,798,800,803,805,807,812,816,819,821,824,826,828,832,834,836,839,848,854,859,863,867,871,874,876,880,884,887,889,892,894,896,901,905,908,910,913,915,917,921,923,925,928,935,939,942,944,947,949,951,955,957,959,962,968,970,972,975,980,995,1005,1013,1019,1026,1032,1037,1041,1047,1053,1058,1062,1066,1070,1073,1075,1081,1087,1092,1096,1100,1104,1107,1109,1113,1117,1120,1122,1125,1127,1129,1136,1142,1147,1151,1155,1159,1162,1164,1168,1172,1175,1177,1180,1182,1184,1189,1193,1196,1198,1201,1203,1205,1209,1211,1213,1216,1225,1231,1236,1240,1244,1248,1251,1253,1257,1261,1264,1266,1269,1271,1273,1278,1282,1285,1287,1290,1292,1294,1298,1300,1302,1305,1312,1316,1319,1321,1324,1326,1328,1332,1334,1336,1339,1345,1347,1349,1352,1357,1369,1375,1380,1384,1388,1392,1395,1397,1401,1405,1408,1410,1413,1415,1417,1422,1426,1429,1431,1434,1436,1438,1442,1444,1446,1449,1456,1460,1463,1465,1468,1470,1472,1476,1478,1480,1483,1489,1491,1493,1496,1501,1511,1515,1518,1520,1523,1525,1527,1531,1533,1535,1538,1544,1546,1548,1551,1556,1565,1567,1569,1572,1577,1585,8,18,26,32,39,45,50,54,60,66,71,75,79,83,86,88,94,100,105,109,113,117,120,122,126,130,133,135,138,140,142,149,155,160,164,168,172,175,177,181,185,188,190,193,195,197,202,206,209,211,214,216,218,222,224,226,229,238,244,249,253,257,261,264,266,270,274,277,279,282,284,286,291,295,298,300,303,305,307,311,313,315,318,325,329,332,334,337,339,341,345,347,349,352,358,360,362,365,370,382,388,393,397,401,405,408,410,414,418,421,423,426,428,430,435,439,442,444,447,449,451,455,457,459,462,469,473,476,478,481,483,485,489,491,493,496,502,504,506,509,514,524,528,531,533,536,538,540,544,546,548,551,557,559,561,564,569,578,580,582,585,590,598,615,621,626,630,634,638,641,643,647,651,654,656,659,661,663,668,672,675,677,680,682,684,688,690,692,695,702,706,709,711,714,716,718,722,724,726,729,735,737,739,742,747,757,761,764,766,769,771,773,777,779,781,784,790,792,794,797,802,811,813,815,818,823,831,846,850,853,855,858,860,862,866,868,870,873,879,881,883,886,891,900,902,904,907,912,920,934,936,938,941,946,954,967,992,998,1003,1007,1011,1015,1018,1020,1024,1028,1031,1033,1036,1038,1040,1045,1049,1052,1054,1057,1059,1061,1065,1067,1069,1072,1079,1083,1086,1088,1091,1093,1095,1099,1101,1103,1106,1112,1114,1116,1119,1124,1134,1138,1141,1143,1146,1148,1150,1154,1156,1158,1161,1167,1169,1171,1174,1179,1188,1190,1192,1195,1200,1208,1223,1227,1230,1232,1235,1237,1239,1243,1245,1247,1250,1256,1258,1260,1263,1268,1277,1279,1281,1284,1289,1297,1311,1313,1315,1318,1323,1331,1344,1367,1371,1374,1376,1379,1381,1383,1387,1389,1391,1394,1400,1402,1404,1407,1412,1421,1423,1425,1428,1433,1441,1455,1457,1459,1462,1467,1475,1488,1510,1512,1514,1517,1522,1530,1543,1564,5,11,16,20,24,28,31,33,37,41,44,46,49,51,53,58,62,65,67,70,72,74,78,80,82,85,92,96,99,101,104,106,108,112,114,116,119,125,127,129,132,137,147,151,154,156,159,161,163,167,169,171,174,180,182,184,187,192,201,203,205,208,213,221,236,240,243,245,248,250,252,256,258,260,263,269,271,273,276,281,290,292,294,297,302,310,324,326,328,331,336,344,357,380,384,387,389,392,394,396,400,402,404,407,413,415,417,420,425,434,436,438,441,446,454,468,470,472,475,480,488,501,523,525,527,530,535,543,556,577,613,617,620,622,625,627,629,633,635,637,640,646,648,650,653,658,667,669,671,674,679,687,701,703,705,708,713,721,734,756,758,760,763,768,776,789,810,845,847,849,852,857,865,878,899,933,990,994,997,999,1002,1004,1006,1010,1012,1014,1017,1023,1025,1027,1030,1035,1044,1046,1048,1051,1056,1064,1078,1080,1082,1085,1090,1098,1111,1133,1135,1137,1140,1145,1153,1166,1187,1222,1224,1226,1229,1234,1242,1255,1276,1310,1366,1368,1370,1373,1378,1386,1399,1420,1454,1509,3,7,10,12,15,17,19,23,25,27,30,36,38,40,43,48,57,59,61,64,69,77,91,93,95,98,103,111,124,146,148,150,153,158,166,179,200,235,237,239,242,247,255,268,289,323,379,381,383,386,391,399,412,433,467,522,612,614,616,619,624,632,645,666,700,755,844,989,991,993,996,1001,1009,1022,1043,1077,1132,1221,1365,2,4,6,9,14,22,35,56,90,145,234,378,611,988,1};
nat  vector16[] = {1597,987,2207,610,1364,1974,2440,377,843,1220,1508,1830,2118,2351,2529,233,521,754,932,1131,1309,1453,1563,1741,1919,2063,2173,2296,2406,2495,2563,144,322,466,576,699,809,898,966,1076,1186,1275,1343,1419,1487,1542,1584,1686,1796,1885,1953,2029,2097,2152,2194,2262,2330,2385,2427,2474,2516,2550,2576,89,199,288,356,432,500,555,597,665,733,788,830,877,919,953,979,1042,1110,1165,1207,1254,1296,1330,1356,1398,1440,1474,1500,1529,1555,1576,1592,1652,1720,1775,1817,1864,1906,1940,1966,2008,2050,2084,2110,2139,2165,2186,2202,2241,2283,2317,2343,2372,2398,2419,2435,2461,2487,2508,2524,2542,2558,2571,2581,55,123,178,220,267,309,343,369,411,453,487,513,542,568,589,605,644,686,720,746,775,801,822,838,864,890,911,927,945,961,974,984,1021,1063,1097,1123,1152,1178,1199,1215,1241,1267,1288,1304,1322,1338,1351,1361,1385,1411,1432,1448,1466,1482,1495,1505,1521,1537,1550,1560,1571,1581,1589,1595,1631,1673,1707,1733,1762,1788,1809,1825,1851,1877,1898,1914,1932,1948,1961,1971,1995,2021,2042,2058,2076,2092,2105,2115,2131,2147,2160,2170,2181,2191,2199,2205,2228,2254,2275,2291,2309,2325,2338,2348,2364,2380,2393,2403,2414,2424,2432,2438,2453,2469,2482,2492,2503,2513,2521,2527,2537,2547,2555,2561,2568,2574,2579,2583,34,76,110,136,165,191,212,228,254,280,301,317,335,351,364,374,398,424,445,461,479,495,508,518,534,550,563,573,584,594,602,608,631,657,678,694,712,728,741,751,767,783,796,806,817,827,835,841,856,872,885,895,906,916,924,930,940,950,958,964,971,977,982,986,1008,1034,1055,1071,1089,1105,1118,1128,1144,1160,1173,1183,1194,1204,1212,1218,1233,1249,1262,1272,1283,1293,1301,1307,1317,1327,1335,1341,1348,1354,1359,1363,1377,1393,1406,1416,1427,1437,1445,1451,1461,1471,1479,1485,1492,1498,1503,1507,1516,1526,1534,1540,1547,1553,1558,1562,1568,1574,1579,1583,1587,1591,1594,1596,1618,1644,1665,1681,1699,1715,1728,1738,1754,1770,1783,1793,1804,1814,1822,1828,1843,1859,1872,1882,1893,1903,1911,1917,1927,1937,1945,1951,1958,1964,1969,1973,1987,2003,2016,2026,2037,2047,2055,2061,2071,2081,2089,2095,2102,2108,2113,2117,2126,2136,2144,2150,2157,2163,2168,2172,2178,2184,2189,2193,2197,2201,2204,2206,2220,2236,2249,2259,2270,2280,2288,2294,2304,2314,2322,2328,2335,2341,2346,2350,2359,2369,2377,2383,2390,2396,2401,2405,2411,2417,2422,2426,2430,2434,2437,2439,2448,2458,2466,2472,2479,2485,2490,2494,2500,2506,2511,2515,2519,2523,2526,2528,2534,2540,2545,2549,2553,2557,2560,2562,2566,2570,2573,2575,2578,2580,2582,21,47,68,84,102,118,131,141,157,173,186,196,207,217,225,231,246,262,275,285,296,306,314,320,330,340,348,354,361,367,372,376,390,406,419,429,440,450,458,464,474,484,492,498,505,511,516,520,529,539,547,553,560,566,571,575,581,587,592,596,600,604,607,609,623,639,652,662,673,683,691,697,707,717,725,731,738,744,749,753,762,772,780,786,793,799,804,808,814,820,825,829,833,837,840,842,851,861,869,875,882,888,893,897,903,909,914,918,922,926,929,931,937,943,948,952,956,960,963,965,969,973,976,978,981,983,985,1000,1016,1029,1039,1050,1060,1068,1074,1084,1094,1102,1108,1115,1121,1126,1130,1139,1149,1157,1163,1170,1176,1181,1185,1191,1197,1202,1206,1210,1214,1217,1219,1228,1238,1246,1252,1259,1265,1270,1274,1280,1286,1291,1295,1299,1303,1306,1308,1314,1320,1325,1329,1333,1337,1340,1342,1346,1350,1353,1355,1358,1360,1362,1372,1382,1390,1396,1403,1409,1414,1418,1424,1430,1435,1439,1443,1447,1450,1452,1458,1464,1469,1473,1477,1481,1484,1486,1490,1494,1497,1499,1502,1504,1506,1513,1519,1524,1528,1532,1536,1539,1541,1545,1549,1552,1554,1557,1559,1561,1566,1570,1573,1575,1578,1580,1582,1586,1588,1590,1593,1610,1626,1639,1649,1660,1670,1678,1684,1694,1704,1712,1718,1725,1731,1736,1740,1749,1759,1767,1773,1780,1786,1791,1795,1801,1807,1812,1816,1820,1824,1827,1829,1838,1848,1856,1862,1869,1875,1880,1884,1890,1896,1901,1905,1909,1913,1916,1918,1924,1930,1935,1939,1943,1947,1950,1952,1956,1960,1963,1965,1968,1970,1972,1982,1992,2000,2006,2013,2019,2024,2028,2034,2040,2045,2049,2053,2057,2060,2062,2068,2074,2079,2083,2087,2091,2094,2096,2100,2104,2107,2109,2112,2114,2116,2123,2129,2134,2138,2142,2146,2149,2151,2155,2159,2162,2164,2167,2169,2171,2176,2180,2183,2185,2188,2190,2192,2196,2198,2200,2203,2215,2225,2233,2239,2246,2252,2257,2261,2267,2273,2278,2282,2286,2290,2293,2295,2301,2307,2312,2316,2320,2324,2327,2329,2333,2337,2340,2342,2345,2347,2349,2356,2362,2367,2371,2375,2379,2382,2384,2388,2392,2395,2397,2400,2402,2404,2409,2413,2416,2418,2421,2423,2425,2429,2431,2433,2436,2445,2451,2456,2460,2464,2468,2471,2473,2477,2481,2484,2486,2489,2491,2493,2498,2502,2505,2507,2510,2512,2514,2518,2520,2522,2525,2532,2536,2539,2541,2544,2546,2548,2552,2554,2556,2559,2565,2567,2569,2572,2577,13,29,42,52,63,73,81,87,97,107,115,121,128,134,139,143,152,162,170,176,183,189,194,198,204,210,215,219,223,227,230,232,241,251,259,265,272,278,283,287,293,299,304,308,312,316,319,321,327,333,338,342,346,350,353,355,359,363,366,368,371,373,375,385,395,403,409,416,422,427,431,437,443,448,452,456,460,463,465,471,477,482,486,490,494,497,499,503,507,510,512,515,517,519,526,532,537,541,545,549,552,554,558,562,565,567,570,572,574,579,583,586,588,591,593,595,599,601,603,606,618,628,636,642,649,655,660,664,670,676,681,685,689,693,696,698,704,710,715,719,723,727,730,732,736,740,743,745,748,750,752,759,765,770,774,778,782,785,787,791,795,798,800,803,805,807,812,816,819,821,824,826,828,832,834,836,839,848,854,859,863,867,871,874,876,880,884,887,889,892,894,896,901,905,908,910,913,915,917,921,923,925,928,935,939,942,944,947,949,951,955,957,959,962,968,970,972,975,980,995,1005,1013,1019,1026,1032,1037,1041,1047,1053,1058,1062,1066,1070,1073,1075,1081,1087,1092,1096,1100,1104,1107,1109,1113,1117,1120,1122,1125,1127,1129,1136,1142,1147,1151,1155,1159,1162,1164,1168,1172,1175,1177,1180,1182,1184,1189,1193,1196,1198,1201,1203,1205,1209,1211,1213,1216,1225,1231,1236,1240,1244,1248,1251,1253,1257,1261,1264,1266,1269,1271,1273,1278,1282,1285,1287,1290,1292,1294,1298,1300,1302,1305,1312,1316,1319,1321,1324,1326,1328,1332,1334,1336,1339,1345,1347,1349,1352,1357,1369,1375,1380,1384,1388,1392,1395,1397,1401,1405,1408,1410,1413,1415,1417,1422,1426,1429,1431,1434,1436,1438,1442,1444,1446,1449,1456,1460,1463,1465,1468,1470,1472,1476,1478,1480,1483,1489,1491,1493,1496,1501,1511,1515,1518,1520,1523,1525,1527,1531,1533,1535,1538,1544,1546,1548,1551,1556,1565,1567,1569,1572,1577,1585,1605,1615,1623,1629,1636,1642,1647,1651,1657,1663,1668,1672,1676,1680,1683,1685,1691,1697,1702,1706,1710,1714,1717,1719,1723,1727,1730,1732,1735,1737,1739,1746,1752,1757,1761,1765,1769,1772,1774,1778,1782,1785,1787,1790,1792,1794,1799,1803,1806,1808,1811,1813,1815,1819,1821,1823,1826,1835,1841,1846,1850,1854,1858,1861,1863,1867,1871,1874,1876,1879,1881,1883,1888,1892,1895,1897,1900,1902,1904,1908,1910,1912,1915,1922,1926,1929,1931,1934,1936,1938,1942,1944,1946,1949,1955,1957,1959,1962,1967,1979,1985,1990,1994,1998,2002,2005,2007,2011,2015,2018,2020,2023,2025,2027,2032,2036,2039,2041,2044,2046,2048,2052,2054,2056,2059,2066,2070,2073,2075,2078,2080,2082,2086,2088,2090,2093,2099,2101,2103,2106,2111,2121,2125,2128,2130,2133,2135,2137,2141,2143,2145,2148,2154,2156,2158,2161,2166,2175,2177,2179,2182,2187,2195,2212,2218,2223,2227,2231,2235,2238,2240,2244,2248,2251,2253,2256,2258,2260,2265,2269,2272,2274,2277,2279,2281,2285,2287,2289,2292,2299,2303,2306,2308,2311,2313,2315,2319,2321,2323,2326,2332,2334,2336,2339,2344,2354,2358,2361,2363,2366,2368,2370,2374,2376,2378,2381,2387,2389,2391,2394,2399,2408,2410,2412,2415,2420,2428,2443,2447,2450,2452,2455,2457,2459,2463,2465,2467,2470,2476,2478,2480,2483,2488,2497,2499,2501,2504,2509,2517,2531,2533,2535,2538,2543,2551,2564,8,18,26,32,39,45,50,54,60,66,71,75,79,83,86,88,94,100,105,109,113,117,120,122,126,130,133,135,138,140,142,149,155,160,164,168,172,175,177,181,185,188,190,193,195,197,202,206,209,211,214,216,218,222,224,226,229,238,244,249,253,257,261,264,266,270,274,277,279,282,284,286,291,295,298,300,303,305,307,311,313,315,318,325,329,332,334,337,339,341,345,347,349,352,358,360,362,365,370,382,388,393,397,401,405,408,410,414,418,421,423,426,428,430,435,439,442,444,447,449,451,455,457,459,462,469,473,476,478,481,483,485,489,491,493,496,502,504,506,509,514,524,528,531,533,536,538,540,544,546,548,551,557,559,561,564,569,578,580,582,585,590,598,615,621,626,630,634,638,641,643,647,651,654,656,659,661,663,668,672,675,677,680,682,684,688,690,692,695,702,706,709,711,714,716,718,722,724,726,729,735,737,739,742,747,757,761,764,766,769,771,773,777,779,781,784,790,792,794,797,802,811,813,815,818,823,831,846,850,853,855,858,860,862,866,868,870,873,879,881,883,886,891,900,902,904,907,912,920,934,936,938,941,946,954,967,992,998,1003,1007,1011,1015,1018,1020,1024,1028,1031,1033,1036,1038,1040,1045,1049,1052,1054,1057,1059,1061,1065,1067,1069,1072,1079,1083,1086,1088,1091,1093,1095,1099,1101,1103,1106,1112,1114,1116,1119,1124,1134,1138,1141,1143,1146,1148,1150,1154,1156,1158,1161,1167,1169,1171,1174,1179,1188,1190,1192,1195,1200,1208,1223,1227,1230,1232,1235,1237,1239,1243,1245,1247,1250,1256,1258,1260,1263,1268,1277,1279,1281,1284,1289,1297,1311,1313,1315,1318,1323,1331,1344,1367,1371,1374,1376,1379,1381,1383,1387,1389,1391,1394,1400,1402,1404,1407,1412,1421,1423,1425,1428,1433,1441,1455,1457,1459,1462,1467,1475,1488,1510,1512,1514,1517,1522,1530,1543,1564,1602,1608,1613,1617,1621,1625,1628,1630,1634,1638,1641,1643,1646,1648,1650,1655,1659,1662,1664,1667,1669,1671,1675,1677,1679,1682,1689,1693,1696,1698,1701,1703,1705,1709,1711,1713,1716,1722,1724,1726,1729,1734,1744,1748,1751,1753,1756,1758,1760,1764,1766,1768,1771,1777,1779,1781,1784,1789,1798,1800,1802,1805,1810,1818,1833,1837,1840,1842,1845,1847,1849,1853,1855,1857,1860,1866,1868,1870,1873,1878,1887,1889,1891,1894,1899,1907,1921,1923,1925,1928,1933,1941,1954,1977,1981,1984,1986,1989,1991,1993,1997,1999,2001,2004,2010,2012,2014,2017,2022,2031,2033,2035,2038,2043,2051,2065,2067,2069,2072,2077,2085,2098,2120,2122,2124,2127,2132,2140,2153,2174,2210,2214,2217,2219,2222,2224,2226,2230,2232,2234,2237,2243,2245,2247,2250,2255,
2264,2266,2268,2271,2276,2284,2298,2300,2302,2305,2310,2318,2331,2353,2355,2357,2360,2365,2373,2386,2407,2442,2444,2446,2449,2454,2462,2475,2496,2530,5,11,16,20,24,28,31,33,37,41,44,46,49,51,53,58,62,65,67,70,72,74,78,80,82,85,92,96,99,101,104,106,108,112,114,116,119,125,127,129,132,137,147,151,154,156,159,161,163,167,169,171,174,180,182,184,187,192,201,203,205,208,213,221,236,240,243,245,248,250,252,256,258,260,263,269,271,273,276,281,290,292,294,297,302,310,324,326,328,331,336,344,357,380,384,387,389,392,394,396,400,402,404,407,413,415,417,420,425,434,436,438,441,446,454,468,470,472,475,480,488,501,523,525,527,530,535,543,556,577,613,617,620,622,625,627,629,633,635,637,640,646,648,650,653,658,667,669,671,674,679,687,701,703,705,708,713,721,734,756,758,760,763,768,776,789,810,845,847,849,852,857,865,878,899,933,990,994,997,999,1002,1004,1006,1010,1012,1014,1017,1023,1025,1027,1030,1035,1044,1046,1048,1051,1056,1064,1078,1080,1082,1085,1090,1098,1111,1133,1135,1137,1140,1145,1153,1166,1187,1222,1224,1226,1229,1234,1242,1255,1276,1310,1366,1368,1370,1373,1378,1386,1399,1420,1454,1509,1600,1604,1607,1609,1612,1614,1616,1620,1622,1624,1627,1633,1635,1637,1640,1645,1654,1656,1658,1661,1666,1674,1688,1690,1692,1695,1700,1708,1721,1743,1745,1747,1750,1755,1763,1776,1797,1832,1834,1836,1839,1844,1852,1865,1886,1920,1976,1978,1980,1983,1988,1996,2009,2030,2064,2119,2209,2211,2213,2216,2221,2229,2242,2263,2297,2352,2441,3,7,10,12,15,17,19,23,25,27,30,36,38,40,43,48,57,59,61,64,69,77,91,93,95,98,103,111,124,146,148,150,153,158,166,179,200,235,237,239,242,247,255,268,289,323,379,381,383,386,391,399,412,433,467,522,612,614,616,619,624,632,645,666,700,755,844,989,991,993,996,1001,1009,1022,1043,1077,1132,1221,1365,1599,1601,1603,1606,1611,1619,1632,1653,1687,1742,1831,1975,2208,2,4,6,9,14,22,35,56,90,145,234,378,611,988,1598,1};

  
    TAvl resultado =crearAvl();
  //  resultado = arregloAAvl(foo,5);
 switch(h) //donde opción es la variable a comparar
{
 case 0: //Bloque de instrucciones 1;
 //  vector[] = {};
 resultado = NULL;
    return resultado;
    case 1: //Bloque de instrucciones 1;
  
    resultado = arregloAAvl(vector,1);
    return resultado;
    break;
    case 2: //Bloque de instrucciones 2;
  
    resultado = arregloAAvl(vector2,2);
    return resultado;
    break;
    case 3: //Bloque de instrucciones 3;

 resultado = arregloAAvl(vector3,4);
    return resultado;
    break;
     case 4: //Bloque de instrucciones 1;
  
   resultado = arregloAAvl(vector4,7);
    return resultado;
    break;
    case 5: //Bloque de instrucciones 2;

   resultado = arregloAAvl(vector5,12);
    return resultado;
    break;
    case 6: //Bloque de instrucciones 3;

  resultado = arregloAAvl(vector6,20);
    return resultado;

    break;
      case 7: //Bloque de instrucciones 3;


  resultado = arregloAAvl(vector7,33);
    return resultado;
    break;
     case 8: //Bloque de instrucciones 1;

 
    resultado = arregloAAvl(vector8,54);
    return resultado;
    break;
    case 9: //Bloque de instrucciones 2;
  
  resultado = arregloAAvl(vector9,88);
    return resultado;
    break;
    case 10: //Bloque de instrucciones 3;


  resultado = arregloAAvl(vector10,143);
    return resultado;
    break;
  case 11: //Bloque de instrucciones 3;
  resultado = arregloAAvl(vector11,232);
    return resultado;
    break;
 case 12: //Bloque de instrucciones 3;
  resultado = arregloAAvl(vector12,376);
    return resultado;
    break;

     case 13: //Bloque de instrucciones 3;
  resultado = arregloAAvl(vector13,609);
    return resultado;
    break;
     case 14: //Bloque de instrucciones 3;
  resultado = arregloAAvl(vector14,986);
    return resultado;
    break;
     case 15: //Bloque de instrucciones 3;


  resultado = arregloAAvl(vector15,1596);
    return resultado;
    break;

     case 16: //Bloque de instrucciones 3;


  resultado = arregloAAvl(vector16,2583);
    return resultado;
    break;

}

return NULL;
}


/*
  Imprime los elementos de cada nivel de 'avl'.
  Imprime una línea por nivel, primero el más profundo y al final el que
  corresponde a la raíz.
  Cada nivel se imprime en orden creciente. Se debe dejar un espacio en
  blanco después de cada número.
  Se puede asumir que 0 no es ningún elemento.
  El tiempo de ejecución en el peor caso es O(n), siendo 'n' la cantidad de
  elementos de 'TAvl'.
  Ver ejemplos en la letra.
 */


void imprimirAvl(TAvl avl){

if ( avl != NULL ) {
  /*
TAvl avl=new repAvl;
*avl=*elavl;
avl->dato=elavl->dato;
*/

TPila s = crearPila(99999999); // stack de naturales auxiliar
TColaAvls q = crearColaAvls(); // queue de á rboles de naturales ←-
  TAvl centinela= crearAvl();
  centinela=insertarEnAvl(99999,centinela);
  q=encolar(avl,q);
  encolar(centinela,q);
while (!estaVaciaColaAvls(q)) {
    avl = frente (q);
    desencolar(q);
    apilar(avl->dato,s);
  if((avl->dato==99999) && (!estaVaciaColaAvls(q))){
         
          encolar(centinela,q);
          }
           else{
    
    if (avl->der!=NULL)
      encolar(avl->der,q);
    if (avl->izq!=NULL)
      encolar(avl->izq,q);
      }
}


desapilar(s);
if(!estaVaciaPila(s)){
while (! estaVaciaPila(s)) {
  if(cima(s)!=99999){
  printf("%d ",cima(s)) ;
  desapilar(s);}
  else {
    printf("\n");
  desapilar(s);
  }
      }
      //liberarAvl(centinela);
    liberarPila(s);
    }  
   printf("\n") ;
   
    //delete avl;
     }
      else {}
     
}




















void imprimirAvln(TAvl avl){

  if (avl!=NULL){
  
   TPila q = crearPila(999);
   q= apilar(avl->dato,q);
   apilar(0,q);

  
  while(!estaVaciaPila(q)){
     // avl->dato=cima(q);
      desapilar(q);
      if((avl->dato==0) && (!estaVaciaPila(q))){
          printf("\n");
          apilar(0,q);
      }else {
      if(avl->dato!=0)
      printf("%d ",avl->dato);
      if(avl->izq!=NULL)
        apilar(avl->izq->dato,q);
      if(avl->der!=NULL)
        apilar(avl->der->dato,q);
        }
  }
}
printf("\n");

}
















//	↓	↓	↓	↓	↓	↓	↓	↓	↓	↓	↓	↓	↓	↓	↓	↓	↓	↓	↓	↓	↓	borrable	↓	↓	↓	↓	↓	↓	↓	↓	↓	↓	↓	↓	↓	↓	↓	↓	↓	↓



void imprimirAvl3(TAvl avl){
  
  if (avl!=NULL){

   TColaAvls q = crearColaAvls();
   q= encolar(avl,q);
  
  while(!estaVaciaColaAvls(q)){
      avl=frente(q);
      desencolar(q);
      printf("%d ",avl->dato);
      if(avl->izq!=NULL)
        encolar(avl->izq,q);
      if(avl->der!=NULL)
        encolar(avl->der,q);
  }
}
}













void imprimirAvl2(TAvl avl){

  if (avl!=NULL){
  int nivel =1;
   cola q = crearcola();
   encolarq(q,avl->dato);
   encolarq(q,0);
   printf("%d - ",nivel);
   while (q.delante !=0){
     //avl= q;
     desencolarq(q);
      if(avl==NULL && q.delante !=0){
        printf("\n %d - ",++nivel);
       encolarq( q,0);
      } else {
          // if(avl->dato!=0)
         //  printf("%d",avl->dato);
          if(avl->izq!=NULL)
           encolarq(q,avl->izq->dato);
          if(avl->der !=NULL)
          encolarq(q,avl->der->dato);
      }
   }
  // liberarColaAvls(q);

  }

}

//***↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑borrable↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑

nat cantidadAvl2(TAvl b){
 if(b== NULL){
return 0;
 } else {

   return 1+cantidadAvl2(b->izq)+cantidadAvl2(b->der);
 }

}














/*
:::::o+-----------------../mNNNNNNNNNmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmNmNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNmyssssssssss
:::::h------------------...:hNNNNNmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNhsssssssss
::::+y-------------://++///+omNNNmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNyssssssss
::::+s---------/+++//:::::::+NNNmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmNNNmddhysooooossyhmNNNNNNNNNNNNNNNNNNNNNNNdssssssss
::::/y------/oo/:::::::::::::hNNmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmNNmho/://://+::-:::+::oshmNNNNNNNNNNNNNNNNNNNNssssssss
:::::y:--:+o+:::::::::::::::-+NmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmNmy+/:::/:-+:+/-+:-//:+::///+yNNNNNNNNNNNNNNNNNNhsssssss
:::::oo-+o/::::::::::::::--:-:mNmmmmmmmmmmmmmmmmmmmNd+/++yNmmmmmmmmmmmmmmy+:----::--/:-/:-:/:-:/://::///+dNNNNNNNNNdyso++smyssssss
::::::ssh/::::::::::::::-----:hNmmmmmmmmmmmmmmmmmmNm:-::::hooyNmmmmmmmNy:----------::--::--:/:-:/:::/:-::/hNNNNNNNm:::::--/yysssss
:::::::/sy/:::::::::::::------oNmmmmmmmmmmmmmmmmmmm+------:/-:yNmmmmmNd-----------------------------------:yNNNNh+s/:::----:hyssss
:::::::::os::::::::::::::-----/NmmmmmmmmmmddmmmmmNd:------:/-::mmmmmmN/-------------------:::::------------:mNNh:-//:::::---:ddddm
::::::::::so::::::::::-:------/Nmmmmmmmmdmmmmmmmmmm:-------//:-hNmmmmm-:-:::::::-----:::::::-:/:------------oNMh:::o/:-------sNNNN
:::::::::::so:::::::::-:------+NmmmmmmmmmmdmmmmmmmN+----::-/---dmmmmmm:-.sy----/:---:/:---+d+://------------:sdd//:+:--::----+NNNN
:::::::::::os::::::::---------oNmmmmmdddmmmmddmmmmNd:------:--+dmmmmmN+-.--.:--::---::`````.``-:--------------:ds::///:+/----yNNNN
::::---:::o+::::::::---------:hNmmmmmddddddddmdmmmmNd:-----:--syyNmmmNs----/----------:---:::/:----------------yNdo::/::----+NNNNN
::------/s+::::::::----------oNmmmmdddddddddddmddmmmNs/----//oooodNNmo-----::-----------------------------::--+mNNmh:::----/hmNNNN
::-----+s/::::::-::---------+mmmmmmdddddddddddddddmmNso++++++++++yNNo-------------------------------------:/ydNNNdshs+/////yhhdNNN
-----:os::::::::--:--------+mmmmmmdddddddddddddddddmNh+++++++++++odNy:--------------:/++ossyyhyso:---------:mNNNNysssssssssyssdNNN
:---/s+::::::::-----------smmmmmddddddddddddddddddddmNy+++++++++++smNmdyssoo+::/yddmNNNMMMMMMMMMNd:--------+mNNNdssssssssssssymNNN
:-:oo/::::::::----------/+dmmmmmddddddddddddddddddddmmms+++++++++++shyyhhddmo-::odddddmmmmmmmmmdh+-------/syymdmyoosssssssssshNNNN
ooo+::::::::---------:/+:.hmmmmmdddddddddddddddddddddmmms+++++++++++sooooooh/----:-::::::::::::------:/+shhsssohsooosssssssssdNNNN
/:::::::::::-------:+o+/+ommmmmddddddddddddddddddddddmmmms++++++++++++oo+osyyy+------------------:/+osooyyooooosooooosssssssyNNNNN
::::::::--------:/sdmddmNmmmmmddddddddddddddddddddddddmmmms+++++++++++++oyssyd+--------------:/osssooooodyooooooooooosssssssmNNNMN
::::::::-----:/sdmmmmmmmNmmmdddddddddddddddddddddddddddmmmmho++++++++++sysossh+------------/osssoooooooysysooooooooooooosssdNNNNNN
y+::::-----:odmmmmmmmmNNmmmmmmmmmmmmmmmmmmmmddddddddddddmmmmdso+++++++shysssooy/---------/ssoooyyoooooysooyysooooooooossssdNNmNNNN
NNdy+/::/+sdmmmmmmmmmNNmmmmmmmmddddddddmmddddddmmmmmmmmmmmmmmmdysoooooysooooooos:-----:+ssooooooshoooysoooooosssssyyyyyhdmNmmmmNNN
NNNNmmddmmmmmmmmmmmmNmmmmddddddddddddddddddddddddddddmmNmmmmmmmmmmdddyo+++++ooos+---/+sooooooooooyysyso+ooooooooosdNNNNNNNmmmmmNNN
mmmmmmmmmmmmmmmmmmNmmmmmmdddddddddddddddddddddddddddddddmmmmmmmmmmmmy++++++++++oso+ooooooooooooo+osoo+++o+ooooooooodNNNNNNNNNNNNNN
mmmmmmmmmmmmmNNNmmmmmmmmmmmdddddddddddddddddddddddddddddmmmmmmmmmmmy++++++++++oooooo+ooooooo+++++++++++oo++o+ooooooodNNmmmNNNNNNMN
mmmmmmmmmNNNNNNmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmNy+++++++++++++++o++ooooooo++++++++++ooooooooooooooomNNNNNNNNNNNN
mmmmmNNNNNmmmmmmmmmmmmmmmdmdmmddddddddddddddddddddddddddddmdddmNNdo+++++++++++++++o++o+o+o+++++++++++++oo++oooooooooosNNNmmmmNNNNN
mmmNNNNNmmmmmmmmmmmmmmmdddddmdddddddddddddddddddddddddddddddddmNNo+++++++++++++++++++++++++o+++++++++++o+++++ooooooooodNmmmmmmmmmN
mmNNNNmmmmmmmmmmmmmmmddddddddddddddddddddddddddddddddddddddddddNd++++++++++++++++++++++++++++++++++++o+o++++oooooooooohNmmmmmmmmmm
mmNNNNNNNmmmmmmmmmmmmdddddddddddddddddddddddddddddddddddddddddmNho+++++++++++++++++++++++++++++++++++++++++++ooooooooodNmmmmmmmmmm
mNNmmmmmmmmmmmmmmmmmmddddddddddddddddddddddddddddddddddddddmddmNdhysoo++++++++++++o++++++++++++++++++++oooooooooossyhhdNNmmmmmmmmm
mNNmmmmmmmmmmmmmmmmmmmmmmmdmdddddmddmmmdddmmddddddddddmdddmmmmmNmyyhhhyysooooooo+++++++++o+++oooo++++ooooossyyhhhhhhhhdNNmmmmmmmmN
mNNmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmNdhyyyyyhhhddhhhyyyyyyysoooooossssyyyhhhhhhhhhhhhhhhhdNNmNNNNNNNNN
mNNmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmdddddNNdddhhhyyyddhhhhddddddmhhhhhhhhhhhhhhhhhhhhhhhhhdddmmNNNNNNNNmNNN
NNNmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmdmmmdddddmmmmmdddddddddddddddmNdhhdddddhmdhhhhhhhhhdmhyyhhhhhhhhhhhhhhdddddddddddddNNmmmmmmmNMN
NNNmmmmmmmmmmmmmmmmmmmmmddddddmmdddddmmdddddddddddddddddddddddddmNmdhhhhhhdddddddddddddmhhhhhddddddddddddddhhhhhhhhdddNmmmmmmmmNMN
NNmmmmmmmmmmmmmmmmmmmmmmddddddddddddddmdddddddddddddddddddddddmmNdhdhhhhhhhhhhhhhhddddddhhhddhhhhhhhhhhhhhhhhhhhhhhhdmNmmmmmmmmNMN
NNmmmmmmmmmmmmmmmmmmmmmmddmmmmddddddmddddddddddddddddddddddddmNmhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhddNNmmmmmmmmNMN
NNmmmmmmmmmmmmmmmmmmmmmmmdmmmmdddddmmmmddddddmmdddddddddddddmNdhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhdmNmmmmmmmmmNMN
NNmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmdddddddddddmmmmmdddddddddddmNdhhhhhhhhhhhhhhhhhhhhhhhhhhhhdhhhhhhhhhhhhhhhhhhhhhhhddNNmmmmmmmmmNMN
NNmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmddmdddmmmmmmmmmmddddddddddmNdhhhhhhhhhhhhhhhhhhdddhhhhhhddhhhhhhhhhhhhhhhhhhhhhhhhdNNmmmmmmmmmmNMN
NNmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmddmdmmmmmmmmmmddmdddddNmhhhhhhhhhhhhhhhhhhhhhhdmmmmmdhhhhhhhhhhhhhhhhhhhhhhhhdNNmmmmmmmmmNNNNN
MNNNmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmNmhhhhhhhhhhhhhhhhhhhhhhdNmmNmhhhhhhhhhhhhhhhhhhhhhdhddNNNNNNNNNNNNNNNNN
MNNNNNNNNNNNNNNNNNNNNNNNmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmNNhhhhhhhhhhhhhhhhhhhhhhNNmNNdhhhhhhhhhhhhhhhhhhhhhddmNNNNNNNNNNNNNNNNNN
NNNNmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmdmmddddddmddddddddddmmddmNdhhhhhhhhhhhhhhhhhhhhhNNmNmhhhhhhhhhhhhhhhhhhhddddmNNmmmmmmmmmNNNNNNNN
NNNmNNmmmmmmmmmmmmmmmmmmmmmmmmmmmmmdddddddddddddddddddddddmNmdhhhhhhhhhhhhhhhhhhhhmNmNmhhhhhhhhhhhhhhhhhhhdddmNNmmmmmmmmmmNNNNNNNN
NNmNNNNmNmmmmmmmmmmmmmmmmmmmmmmmmmmmmmddmmdddmmdddddddddddmmNNdhhhhhhhhhhhhhhhhhhhhmNNNdhhhhhhhhhhhhhhhhddddddNNmmmmmmNmNNNNNNNNNN
NNmNNmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmdmmddmdddddddddmmNdhhhhhhhhhhhhhhhhhhhhdNNNmhhhhhhhhhhhhhhdddddddddNNmmmmNNNNNmNNNNNNN
NNNNNNmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmddmmmmdddddddddddmNmhhhhhhhhhhhhhhhhhhhdmNNmmNmdhhhhhhhhhddddddddddddmNNmmmmNNNmmNNNNNNN
NNNNNNNNNmNmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmdddddddddmmmmNmdhhhhhhhhhhhhdddmdddNmmmmNNmdhhhhddddddddddddddmNNmNmNNNNmNNNNNNNNN
NNNNNNNNNNNNmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmdmmmmmmNmdddddddddddddddhhhdNNmmmmmNNdhddddddddddddddmmmmNNNNNNNNNNNNNNNNNNN
NNNNNNNNNNNNNNmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmNdhyyhhhhhhhhhhhhhhdNNmmmmmmmNNmdddddddddmmmmmmmddmNNNNNNNNmmNNNNNNNNN
NNNNNNNNNNNNNNmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmNmhhhhhhhhhhhhhhhhdmNNmmmmmmmmmNNdddddddmmmmddddddmNNNNNNNNNNNmNNNNNNNNN
NNNNNNNNNNNNNNNNNNNmmNmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmNNdhhhhhhhhhhhhhddmNNmmmmmmmmmmmNNdhddddddddddddddmNNNNNNNNNNNNNNmmmmNNNNN
NNNNNNNNNNNNNNNNNNNNNNmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmNdhhhhhhhhhddmmNNmmmmmmmmmmmmmNNmddddddddddddddmNNNNNNNNNNNNNNNNNmNmmNNNNN
NNNNNNNNNNNNNNNNNNNNNmmmNNNmmmmmmmmmmmmmmmmmmmmmmmmmmmmmNmmmmmmmmNNNmmdmmmmmmmmmmmmmmNNddddddddddddmmNNNNNNNNNNNNNNNNNNNNNNmmNNNNN
NNNNNNNNNNNNNNNNNNNNNoysNNmNmmNmN:dmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmd-NmmmmmmmmmmmmmNdddddddmoyNNNNNNNNNNNNNNNNNmNNNNNNNNNNmmmNNN
NNNNNNNNNNNNNNNNNNNNNoNN+so+y/mNN:os/mys+os/y+d/osod+d+mmmss/ysoy/doos-Nmmss/yooy/doss/y:yyydoyhNNNNNNNNNNNNNNNNNNNNNNNNNNNmmmmmNN
NNNNNNNNNNNNNNNNNNNNNoNN+mhoNodNN:dm:d+s+/som/h/hm/Ns:hNmd/s/osdN+h+dd-Nmd/s+sodmsd/dd/y+NN//dmmNNNNNNNNNNNNNNNNNNNmNNNNNNNNNNNNNN
NNNNNNNNNNNNNNNNNNNNNdNNhNmdNdNNNhmNhNhhhhs+yhN/sydNhsNmmmyhhddmNhmmyhyNmmyhhddmNdmyys/ddNNosNmmNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN
NNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNddNNNymNNNymmmmmmmmmmNmmmNmmmmmmmmNmNNNNNdsymNNNmyNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN
*/







 


/*                        Encolar elemento      
------------------------------------------------------------------------*/
void encolarq( struct cola &q, int valor )
{
     struct nodo *aux = new(struct nodo);
     
     aux->nro = valor;
     aux->sgte = NULL;
     
     if( q.delante == NULL)
         q.delante = aux;   // encola el primero elemento
     else
         (q.atras)->sgte = aux;
         
     q.atras = aux;        // puntero que siempre apunta al ultimo elemento
     
}
 
/*                        Desencolar elemento      
------------------------------------------------------------------------*/
int desencolarq( struct cola &q )
{
     int num ;
     struct nodo *aux ;
     
     aux = q.delante;      // aux apunta al inicio de la cola
     num = aux->nro;
     q.delante = (q.delante)->sgte;
     delete(aux);          // libera memoria a donde apuntaba aux
     
     return num;
}
 

/*              Eliminar todos los elementos de la Cola      
------------------------------------------------------------------------*/
void vaciarCola( struct cola &q)
{
     struct nodo *aux;
     
     while( q.delante != NULL)
     {
            aux = q.delante;
            q.delante = aux->sgte;
            delete(aux);
     }
     q.delante = NULL;
     q.atras   = NULL;
     
}
 


// esta poronga funciono pero hace todo al reves

void imprimirAvlreves(TAvl avl){
  TAvl centinela= crearAvl();
  centinela=insertarEnAvl(0,centinela);
  if (avl!=NULL){
   //int nivel=1;
   TColaAvls q = crearColaAvls();
   q= encolar(avl,q);
   encolar(centinela,q);
  // printf("%d- ",nivel);
  
  while(!estaVaciaColaAvls(q)){
      avl=frente(q);
      desencolar(q);
      if((avl->dato==0) && (!estaVaciaColaAvls(q))){
          printf("\n");
          encolar(centinela,q);
      }else {
      if(avl->dato!=0)
      printf("%d ",avl->dato);
      if(avl->izq!=NULL)
        encolar(avl->izq,q);
      if(avl->der!=NULL)
        encolar(avl->der,q);
        }
  }
}
printf("\n");

}


void imprimirBinario2avl(TAvl b,int cont){
   if( b==NULL){
     return;

   } else {
                
                imprimirBinario2avl(b->der,cont+1); 
                for(int i=0;i<cont;i++){
                  printf("-");
                } 
                printf("(");
                printf("%d", b->dato);
                printf(", %d",b->altura); 
                printf(", %d",b->cantidad); 
                printf(")"); 
                printf("\n");
              
               imprimirBinario2avl(b->izq,cont+1);  
                
            }
         

   }
   
void imprimirBinarioavl(TAvl b){
     printf("\n");
  imprimirBinario2avl(b,0);
 
}




TCadena factorial(nat n, TCadena cadena, nat sumador){
//TCadena cadena = crearCadena();
 
    if(n >= 1){
        
        cadena= factorial(n-1,cadena,0);
        cadena= insertarAntes(crearInfo(longitud(cadena),0),inicioCadena(cadena),cadena);
         cadena= factorial2(n-2,cadena,longitud(cadena));
        imprimirCadena(cadena);
        return cadena;
        }

       else if (n==0) {
        cadena =insertarAlFinal(crearInfo(0+sumador,0),cadena);

        return cadena;
        } else 
  return cadena;  
 }


TCadena factorial2(nat n, TCadena cadena, nat sumador){
//TCadena cadena = crearCadena();
 
    if(n >= 1){
        
        cadena= factorial2(n-1,cadena,0);
        cadena= insertarAntes(crearInfo(longitud(cadena),0),inicioCadena(cadena),cadena);
         //cadena= factorial(n-2,cadena,longitud(cadena));
        imprimirCadena(cadena);
        return cadena;
       
        }

    else if (n==0) {
        cadena =insertarAlFinal(crearInfo(0+sumador,0),cadena);

        return cadena;
        } else 
  return cadena;   
 }










































































/*

TAvl insertarEnAvl4(nat elem, TAvl avl){
assert(estaVacioAvl(buscarEnAvl(elem, avl)));
insertarEnAvl3(elem,avl);
 return avl;
}



void insertarEnAvl3(nat elem, TAvl & avl){


    if (avl== NULL){
      avl= new repAvl;
      avl->dato= elem;
      avl->izq= avl->der= NULL;
      avl->altura= 1;
      avl->cantidad=1;
    } 

    else {
     if (elem< avl->dato){
      insertarEnAvl3(elem,avl->izq);
      avl->altura=max(alturaDeAvl(avl->izq),alturaDeAvl(avl->der))+1;

      //hacemos el balanceo
      int FB= alturaDeAvl(avl->izq)-alturaDeAvl(avl->der);

      if(FB!=0) 
      {
        // solo puede aumentar la altura del arbol izquierod
          if(alturaDeAvl(avl->izq->izq)>alturaDeAvl(avl->izq->der)){
          rotarDerecha2(avl);
         }
          else
          {
           rotarIzquierda2(avl->izq);
           rotarDerecha2(avl);
          }
         }
        }
       
    
      else {  // rlrm mayor que dato 
          insertarEnAvl3(elem,avl->der);
 
          avl->altura=max(alturaDeAvl(avl->izq),alturaDeAvl(avl->der))+1;
          //balanceo
          int FB= alturaDeAvl(avl->izq)-alturaDeAvl(avl->der);

           if(FB< -1) {

          if(alturaDeAvl(avl->der->der)>alturaDeAvl(avl->der->izq))

          rotarIzquierda2(avl);
          else{
           rotarDerecha2(avl->der);
            rotarIzquierda2(avl);
           
          }
      }
       
    }

   
}
}




void rotarDerecha2 ( TAvl & avl) { // precond : z y z - > izq != NULL
assert((avl!=NULL) && (avl->izq!=NULL ));
TAvl y = avl-> izq ;
TAvl T3 = y-> der ;
y-> der = avl;
avl-> izq = T3 ;

avl-> altura = max ( alturaDeAvl (avl-> izq ) , alturaDeAvl (avl-> der ) ) + 1;
y-> altura = max ( alturaDeAvl (y-> izq ) , alturaDeAvl (y-> der ) ) + 1;
y->cantidad=cantidadAvl2(y);

avl = y;
/////////////////////////////borrar//////////////////////////////////////////////
//avl-> cantidad = cantidadEnAvl (avl-> izq ) +  cantidadEnAvl (avl-> der )  + 1;
//T3-> cantidad =  cantidadEnAvl (T3-> izq ) + cantidadEnAvl (T3-> der )  + 1;
///////////////////////////borrar?///////////////////////////////////////////////
avl->cantidad= cantidadAvl2(avl);


}

void rotarIzquierda2 ( TAvl & avl ) { // precond : el z y z - > der != NULL
assert((avl!=NULL) && (avl->der!=NULL ));

TAvl y = avl-> der ;
TAvl T2 = y-> izq ;
y-> izq = avl ;

avl-> der = T2 ;

avl-> altura = max ( alturaDeAvl (avl-> izq ) , alturaDeAvl (avl-> der ) ) +1;
y-> altura = max ( alturaDeAvl (y-> izq ) , alturaDeAvl (y-> der ) ) +1;
y->cantidad=cantidadAvl2(y);



avl = y;
/////////////////////////////borrar//////////////////////////////////////////////
//avl-> cantidad = cantidadEnAvl (avl-> izq ) +  cantidadEnAvl (avl-> der )  + 1;
//T2-> cantidad =  cantidadEnAvl (T2-> izq ) + cantidadEnAvl (T2-> der )  + 1;

///////////////////////////borrar?///////////////////////////////////////////////
avl->cantidad= cantidadAvl2(avl);

}



TAvl insertarEnTavl(nat i, TAvl b){
//assert(esVacioBinario(buscarSubarbol(natInfo(i),b)));
insertarNodo(b,i);
//free(i);
return b;
}
// Funcion insertar elementos en el arbol
void insertarNodo (TAvl & avl, nat i)
{// si el arbol esta vacio
  if (avl== NULL){
      avl= new repAvl;
      avl->dato=i;
      avl->izq= avl->der= NULL;
      avl->altura= 1;
      avl->cantidad=1;
    } 
               
  else {

   //le agregamos la condicion de que si es igual no haga nada para poder de esa manera
   //evitar que repita pasos y me meta dos nodos con el mismo valor.
             nat valorRaiz= raizAvl(avl);
            if (i<(valorRaiz)){
            insertarNodo(avl->izq,i);}
            else if (i>(valorRaiz)){
            insertarNodo(avl->der,i);
            }
     }
 }



nat alturaBinario(TAvl b){
  if (b==NULL)
    return 0;
    else {
        nat altura_izq=alturaBinario(b->izq);
        nat altura_der=alturaBinario(b->der);

      if (altura_izq>=altura_der)
              return altura_izq+1;
      else  
              return altura_der+1;
    }
}
*/
